import * as i0 from '@angular/core';
import { Injectable, EventEmitter, Component, Input, Output, NgModule } from '@angular/core';
import { faUpDownLeftRight, faUpRightAndDownLeftFromCenter, faPowerOff } from '@fortawesome/free-solid-svg-icons';
export * from '@fortawesome/free-solid-svg-icons';
import * as i1 from '@fortawesome/angular-fontawesome';
import { FontAwesomeModule } from '@fortawesome/angular-fontawesome';
export * from '@fortawesome/angular-fontawesome';
import * as i2 from '@angular/common';
import { CommonModule } from '@angular/common';
export * from '@fortawesome/fontawesome-svg-core';

class CapsuleFluxService {
    constructor() { }
}
CapsuleFluxService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.5", ngImport: i0, type: CapsuleFluxService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
CapsuleFluxService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.2.5", ngImport: i0, type: CapsuleFluxService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.5", ngImport: i0, type: CapsuleFluxService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

//import { CycleEnum, EtatEnum, ZoneEnum } from './capsule-flux.service';
var EtatEnum;
(function (EtatEnum) {
    EtatEnum[EtatEnum["Libre"] = 0] = "Libre";
    EtatEnum[EtatEnum["HS"] = 1] = "HS";
    EtatEnum[EtatEnum["Inconnu"] = 2] = "Inconnu";
    EtatEnum[EtatEnum["Ok"] = 3] = "Ok";
})(EtatEnum || (EtatEnum = {}));
var ZoneEnum;
(function (ZoneEnum) {
    ZoneEnum[ZoneEnum["Moniteur"] = 0] = "Moniteur";
    ZoneEnum[ZoneEnum["MI"] = 1] = "MI";
})(ZoneEnum || (ZoneEnum = {}));
var CycleEnum;
(function (CycleEnum) {
    CycleEnum[CycleEnum["Non"] = 0] = "Non";
    CycleEnum[CycleEnum["Oui"] = 1] = "Oui";
})(CycleEnum || (CycleEnum = {}));
class Capsule {
    constructor() {
        this.etat = EtatEnum.Libre;
        this.zone = ZoneEnum.Moniteur;
        this.estCycle = CycleEnum.Non;
        this.numero = 1;
        this.camera = "";
        this.gare = "";
    }
}
class CapsuleFluxComponent {
    constructor() {
        this.faUpDownLeftRight = faUpDownLeftRight;
        this.faUpRightAndDownLeftFromCenter = faUpRightAndDownLeftFromCenter;
        this.faPowerOff = faPowerOff;
        this.capsule = undefined;
        this.OndeplacerClick = new EventEmitter();
        this.OnchangerVisionClick = new EventEmitter();
        this.OnfermerClick = new EventEmitter();
    }
    ngOnInit() {
    }
    deplacerClick() {
        this.OndeplacerClick.emit(this.capsule);
    }
    changerVisionClick() {
        this.OnchangerVisionClick.emit(this.capsule);
    }
    fermerClick() {
        this.OnfermerClick.emit(this.capsule);
    }
    GetStrokeColor() {
        switch (this.capsule?.etat) {
            case EtatEnum.Inconnu:
                return "Purple";
            case EtatEnum.HS:
                return "Red";
            case EtatEnum.Libre:
                return "Yellow";
            case EtatEnum.Ok:
                return "Black";
        }
        return "white";
    }
    EstMI() {
        return this.capsule?.zone == ZoneEnum.MI;
    }
    GetClass() {
        if (this.capsule?.etat == EtatEnum.Ok) {
            if (this.capsule?.estCycle == CycleEnum.Oui)
                return "Cycle";
            else {
                if (this.capsule?.zone == ZoneEnum.Moniteur)
                    return "Moniteur";
                else
                    return "EtatLibre";
            }
        }
        else if (this.capsule?.etat == EtatEnum.Inconnu)
            return "EtatInconnu";
        else if (this.capsule?.etat == EtatEnum.HS)
            return "EtatHS";
        else
            (this.capsule?.etat == EtatEnum.Libre);
        return "EtatLibre";
        /*switch (this.etat) {
          case EtatEnum.Inconnu:
            return "EtatInconnu";
          case EtatEnum.HS:
            return "EtatHS";
          case EtatEnum.Libre:
            return "EtatLibre";
          case EtatEnum.Ok:
            return "Moniteur";
            if(this.estCycle == CycleEnum.Oui){
              return "Cycle";
            }
            else {
              switch (this.zone) {
                case ZoneEnum.Moniteur:
                  return "Moniteur";
                case ZoneEnum.MI:
                  return "MI";
              }
            }
        }*/
    }
}
CapsuleFluxComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.5", ngImport: i0, type: CapsuleFluxComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
CapsuleFluxComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.5", type: CapsuleFluxComponent, selector: "lib-capsule-flux", inputs: { capsule: "capsule" }, outputs: { OndeplacerClick: "OndeplacerClick", OnchangerVisionClick: "OnchangerVisionClick", OnfermerClick: "OnfermerClick" }, ngImport: i0, template: "<div class=\"fenetre\" [ngClass]=\"GetClass()\" >\r\n\r\n    <div class=\"numberCircle\">{{ capsule?.numero }}</div>\r\n    <div>{{ capsule?.gare }}</div>\r\n    <div>{{ capsule?.camera }}</div>\r\n    <div class=\"gridButton\">\r\n        <button class=\"btn btn-outline-dark btn-sm\" (click)=\"deplacerClick()\">\r\n            <fa-icon [icon]=\"faUpDownLeftRight\"></fa-icon>\r\n        </button>\r\n        <button class=\"btn btn-outline-dark btn-sm\" *ngIf=\"!EstMI()\" (click)=\"changerVisionClick()\">\r\n            <fa-icon [icon]=\"faUpRightAndDownLeftFromCenter\"></fa-icon>\r\n        </button>\r\n        <button class=\"btn btn-outline-dark btn-sm\" (click)=\"fermerClick()\">\r\n            <fa-icon [icon]=\"faPowerOff\"></fa-icon>\r\n        </button>\r\n    </div>\r\n</div>", styles: [".fenetre{border-radius:7px;width:100px;height:100px;color:#fff;font-weight:700;text-align:center;border:1px solid;border-color:#000;position:relative}.fenetre>.numberCircle{border-radius:50%;width:20px;height:20px;background:#fff;border:2px solid orange;color:#000;text-align:center;font:700 16px arial}.fenetre>button{padding:1px;width:20px;height:20px;margin:1px;position:absolute;bottom:0;left:0;border:#000}.fenetre>.gridButton{position:absolute;bottom:0;margin:1px 1px 3px}.EtatLibre{border-color:gray;background-color:#fff}.EtatHS{border-color:red;background-color:#fff}.EtatInconnu{border-color:purple;background-color:#fff}.Moniteur{border-color:gray;background-color:#00f}.Mi{border-color:gray;background-color:#90ee90}.Cycle{border-color:#000;background-color:gray}\n"], dependencies: [{ kind: "component", type: i1.FaIconComponent, selector: "fa-icon", inputs: ["icon", "title", "spin", "pulse", "mask", "styles", "flip", "size", "pull", "border", "inverse", "symbol", "rotate", "fixedWidth", "classes", "transform", "a11yRole"] }, { kind: "directive", type: i2.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.5", ngImport: i0, type: CapsuleFluxComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-capsule-flux', template: "<div class=\"fenetre\" [ngClass]=\"GetClass()\" >\r\n\r\n    <div class=\"numberCircle\">{{ capsule?.numero }}</div>\r\n    <div>{{ capsule?.gare }}</div>\r\n    <div>{{ capsule?.camera }}</div>\r\n    <div class=\"gridButton\">\r\n        <button class=\"btn btn-outline-dark btn-sm\" (click)=\"deplacerClick()\">\r\n            <fa-icon [icon]=\"faUpDownLeftRight\"></fa-icon>\r\n        </button>\r\n        <button class=\"btn btn-outline-dark btn-sm\" *ngIf=\"!EstMI()\" (click)=\"changerVisionClick()\">\r\n            <fa-icon [icon]=\"faUpRightAndDownLeftFromCenter\"></fa-icon>\r\n        </button>\r\n        <button class=\"btn btn-outline-dark btn-sm\" (click)=\"fermerClick()\">\r\n            <fa-icon [icon]=\"faPowerOff\"></fa-icon>\r\n        </button>\r\n    </div>\r\n</div>", styles: [".fenetre{border-radius:7px;width:100px;height:100px;color:#fff;font-weight:700;text-align:center;border:1px solid;border-color:#000;position:relative}.fenetre>.numberCircle{border-radius:50%;width:20px;height:20px;background:#fff;border:2px solid orange;color:#000;text-align:center;font:700 16px arial}.fenetre>button{padding:1px;width:20px;height:20px;margin:1px;position:absolute;bottom:0;left:0;border:#000}.fenetre>.gridButton{position:absolute;bottom:0;margin:1px 1px 3px}.EtatLibre{border-color:gray;background-color:#fff}.EtatHS{border-color:red;background-color:#fff}.EtatInconnu{border-color:purple;background-color:#fff}.Moniteur{border-color:gray;background-color:#00f}.Mi{border-color:gray;background-color:#90ee90}.Cycle{border-color:#000;background-color:gray}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { capsule: [{
                type: Input
            }], OndeplacerClick: [{
                type: Output
            }], OnchangerVisionClick: [{
                type: Output
            }], OnfermerClick: [{
                type: Output
            }] } });

class CapsuleFluxModule {
}
CapsuleFluxModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.5", ngImport: i0, type: CapsuleFluxModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
CapsuleFluxModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.5", ngImport: i0, type: CapsuleFluxModule, declarations: [CapsuleFluxComponent], imports: [FontAwesomeModule,
        CommonModule], exports: [CapsuleFluxComponent,
        CommonModule] });
CapsuleFluxModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.5", ngImport: i0, type: CapsuleFluxModule, imports: [FontAwesomeModule,
        CommonModule, CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.5", ngImport: i0, type: CapsuleFluxModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        CapsuleFluxComponent
                    ],
                    imports: [
                        FontAwesomeModule,
                        CommonModule
                    ],
                    exports: [
                        CapsuleFluxComponent,
                        CommonModule
                    ]
                }]
        }] });

/*
 * Public API Surface of capsule-flux
 */

/**
 * Generated bundle index. Do not edit.
 */

export { Capsule, CapsuleFluxComponent, CapsuleFluxModule, CapsuleFluxService, CycleEnum, EtatEnum, ZoneEnum };
//# sourceMappingURL=capsule-flux.mjs.map
